mod Ex03c

incl Mtex

loc rem 
  \para \bf  3. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end pondelok 23.2.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane klauzalnym 
  definiciam, chvostovej rekurzii a celociselnej odmocnine. Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  [CL] Remark.  \end Note that the square function 
  \def 
    fun Sq 'Tex_f1_n_sq'
    Sq(x) = x*x
  \end
  \para is defined in the included module \it  Standard  \end. 

rem 
  \para \bf  Integer Square Root (case study).  \end Specification: 
  \eq* 
    Sq Tex_f1_n_sqrt(x) <= x & x < Sq(Tex_f1_n_sqrt(x)+1)
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Square root function.  \end 

fun Sqrt1 'Tex_f1_n_sqrt'
  Sqrt1(x) = Foo

rem 
  \para \bf  Square root with assignments.  \end 

fun Sqrt2 'Tex_f1_n_sqrt'
  Sqrt2(x) = Foo

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Bottom up program for the square root function I.  \end 

fun/2 F3 'Tex_f2_f'
  F3(x,r) = Foo

rem 
  \para Invariant 
  \eq* 
    Sq(r) <= x -> Sq F3(x,r) <= x & x < Sq(F3(x,r)+1)
  \end

fun Sqrt3 'Tex_f1_n_sqrt'
  Sqrt3(x) = Foo

rem 
  \para \bf  Bottom up program for the square root function II.  \end 

fun/3 F4 'Tex_f3_f'
  F4(x,r,s) = Foo

rem 
  \para Invariant 
  \eq* 
    Sq(r) <= x -> Sq F4(x,r,Sq(r)) <= x & x < Sq(F4(x,r,Sq(r))+1)
  \end

fun Sqrt4 'Tex_f1_n_sqrt'
  Sqrt4(x) = Foo

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. \ft p \end-ary arithmetic.  \end 

rem 
  \para \bf  A fast program for the square root function.  \end 

fun Sgn 'Tex_f1_n_sgn'
  Sgn(0) = 0
  Sgn(x) = 1 <- x != 0

fun Sqrt5 'Tex_f1_n_sqrt'
  Sqrt5(x) = Foo <- x = 4*y+z & 0 <= z & z <= 3

